<?xml version="1.0" encoding="UTF-8" ?>
<object class="Robot" serializationversion="2">
  <prologue>
    <saved-by-versions>
      <version>10.7.0.4</version>
    </saved-by-versions>
    <comment/>
    <tags/>
    <referenced-types/>
    <referenced-snippets/>
    <triggers/>
    <typed-variables/>
    <global-variables/>
    <parameters/>
    <return-variables/>
    <store-in-database-variables/>
    <device-mappings/>
    <browser-engine>WEBKIT</browser-engine>
  </prologue>
  <property name="variables" class="Variables">
    <object class="Variable" serializationversion="1">
      <property name="name" class="String" id="0">項目データ</property>
      <property name="initialAssignment" class="InitialVariableAssignment">
        <property name="type" class="SimpleTypeReference">
          <property name="simpleTypeId" class="Integer">12</property>
        </property>
      </property>
    </object>
    <object class="Variable" serializationversion="1">
      <property name="name" class="String" id="1">行データ</property>
      <property name="global" class="Boolean">true</property>
      <property name="initialAssignment" class="InitialVariableAssignment">
        <property name="type" class="SimpleTypeReference">
          <property name="simpleTypeId" class="Integer">13</property>
        </property>
      </property>
    </object>
  </property>
  <property name="proxyServerConfiguration" class="ProxyServerConfiguration" serializationversion="0"/>
  <property name="httpClientType" class="HttpClientType">
    <property name="enum-name" class="String">WEBKIT</property>
  </property>
  <property name="ntlmAuthentication" class="NTLMAuthenticationType">
    <property name="enum-name" class="String">STANDARD</property>
  </property>
  <property name="usePre96DefaultWaiting" class="Boolean" id="2">false</property>
  <property name="maxWaitForTimeout" class="Integer">10000</property>
  <property name="waitRealTime" idref="2"/>
  <property name="privateHTTPCacheEnabled" class="Boolean" id="3">true</property>
  <property name="privateHTTPCacheSize" class="Integer">2048</property>
  <property name="comment">
    <null/>
  </property>
  <property name="tags" class="RobotTagList"/>
  <property name="humanProcessingTime">
    <null/>
  </property>
  <property name="executionMode" class="ExecutionMode">
    <property name="enum-name" class="String">DIRECT</property>
  </property>
  <property name="avoidExternalReExecution" idref="2"/>
  <property name="transitionGraph" class="Body">
    <blockBeginStep class="BlockBeginStep" id="4"/>
    <steps class="ArrayList">
      <object class="Transition" serializationversion="3" id="5">
        <property name="name" class="String">Excelファイルを読み込む</property>
        <property name="stepAction" class="LoadFile">
          <property name="fileNameExpression" class="kapow.robot.plugin.common.support.expression.stringexpr.FileNameValueStringExpression">
            <property name="value" class="String">C:\演習問題32\出力\ホテル名一覧出力.xlsx</property>
          </property>
          <property name="browserConfigurationSpecification" class="BrowserConfigurationSpecificationWebKit" serializationversion="26">
            <property name="ancestorProvider" class="BrowserConfigurationSpecificationAncestorProviderForStep"/>
          </property>
        </property>
        <property name="elementFinders" class="ElementFinders" id="6"/>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">Excelファイルを読み込む
-----------------------------------------------
ロボットビューの矢印を右クリック
→「ステップを挿入」＞「アクションステップ」を選択
→ステップビュー（画面右）の「アクションを選択」をクリック
→「ファイル」＞[ファイル読込]を選択
→「ファイル名」項目に読み込むExcelファイルのフルパス（C:\演習問題32\出力\ホテル名一覧出力.xlsx）を入力</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element class="String" id="7">name</element>
        </property>
      </object>
      <object class="Transition" serializationversion="3" id="8">
        <property name="name" class="String">読み取り専用でExcelを開く</property>
        <property name="stepAction" class="ViewAsExcel"/>
        <property name="elementFinders" idref="6"/>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">読み取り専用でExcelを開く
-----------------------------------------------
「アクションを選択」をクリック＞[開く（読み取り専用）]を選択</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element idref="7"/>
        </property>
      </object>
      <object class="Transition" serializationversion="3" id="9">
        <property name="name" class="String">行を繰り返し</property>
        <property name="stepAction" class="LoopInExcel">
          <property name="loopDirection" class="LoopInExcel$LoopDirection">
            <property name="enum-name" class="String">ROWS</property>
          </property>
        </property>
        <property name="elementFinders" class="ElementFinders">
          <object class="ExcelElementFinder">
            <property name="detail" class="SpecifiedRangeCellFinderDetail">
              <property name="range" class="kapow.robot.plugin.common.support.expression.stringexpr.ValueStringExpression">
                <property name="value" class="String">Sheet!</property>
              </property>
            </property>
          </object>
        </property>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">行を繰り返し
-----------------------------------------------
ExcelのAと１の間をクリック＞右クリック
→「ループ」＞「選択中の行をループ」＞[最初の行を含める]を選択
</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element idref="7"/>
        </property>
      </object>
      <object class="BranchPoint" id="10"/>
      <object class="Transition" serializationversion="3" id="11">
        <property name="name" class="String">（繰り返し行内で）セルを繰り返し</property>
        <property name="stepAction" class="LoopInExcel">
          <property name="loopDirection" class="LoopInExcel$LoopDirection">
            <property name="enum-name" class="String">CELLS</property>
          </property>
        </property>
        <property name="elementFinders" class="ElementFinders">
          <object class="ExcelElementFinder">
            <property name="detail" class="NamedRangeCellFinderDetail">
              <property name="rangeName" class="ElementName">
                <property name="name" class="String">1</property>
              </property>
            </property>
          </object>
        </property>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">（繰り返し行内で）セルを繰り返し
-----------------------------------------------
A列をクリック＞右クリック
→「ループ」＞[選択中のセルをループ]を選択
→追加されたステップを選択し、[ファインダー]タブを選択
→「指定した範囲を選択」をクリックしてプルダウンし、[名前付き範囲で検索]を選択
→「範囲」の欄の「名前付き範囲を選択」をクリックして、[1]を選択</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element class="String" id="12">name</element>
        </property>
      </object>
      <object class="Transition" serializationversion="3" id="13">
        <property name="name" class="String">項目データを抽出</property>
        <property name="stepAction" class="ExtractCell">
          <property name="attributeName" class="kapow.robot.plugin.common.support.AttributeName2">
            <property name="name" idref="0"/>
          </property>
        </property>
        <property name="elementFinders" class="ElementFinders">
          <object class="ExcelElementFinder">
            <property name="detail" class="NamedRangeCellFinderDetail">
              <property name="rangeName" class="ElementName">
                <property name="name" class="String">2</property>
              </property>
            </property>
          </object>
        </property>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">項目データを抽出
-----------------------------------------------
■変数項目を作成
変数ビュー（画面右下）の＋ボタンをクリック
→名前の欄に[項目データ]と入力
→タイプと初期欄で[[ShortText]を選択

■値を抽出
A1を選択＞右クリック
→「抽出」＞「テキスト」＞変数[項目データ]を選択</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element class="String">name</element>
        </property>
      </object>
      <object class="Transition" serializationversion="3" id="14">
        <property name="name" class="String">変数「項目データ」を加工</property>
        <property name="stepAction" class="AssignVariable" serializationversion="4">
          <property name="stringExpr" class="Expression" serializationversion="1">
            <property name="text" class="String">行データ+&gt;&gt;,"&lt;&lt;+項目データ+&gt;&gt;"&lt;&lt;</property>
          </property>
          <property name="variable" class="kapow.robot.plugin.common.support.AttributeName2">
            <property name="name" idref="1"/>
          </property>
        </property>
        <property name="elementFinders" class="ElementFinders"/>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">変数「項目データ」を加工
-----------------------------------------------
■変数行データを作成
変数ビュー（画面右下）の＋ボタンをクリック
→名前の欄に[行データ]と入力
→グローバルにチェックをいれる
→タイプと初期欄で[LongText]を選択
※行データは、取得した値を保持していくため、グローバルにチェックをいれておく

■変数「項目データ」を加工して変数「行データ」に格納
ロボットビューの矢印を右クリック＞「ステップを挿入」＞[アクションステップ]を選択
→ステップビュー（画面右）の「アクションを選択」をクリック→「変数の割当」を選択
→値欄の▼をプルダウン＞[エクスプレッション]を選択
→[行データ+&gt;&gt;,"&lt;&lt;+項目データ+&gt;&gt;"&lt;&lt;]を入力
※取得した項目データを[,"変数"] の形式に加工し、なおかつ同じ行の項目データをすべて変数[行データ]にためていく

</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element idref="12"/>
        </property>
      </object>
      <object class="End" id="15"/>
      <object class="Transition" serializationversion="3" id="16">
        <property name="name" class="String">変数「行データ」を加工</property>
        <property name="stepAction" class="AssignVariable" serializationversion="4">
          <property name="stringExpr" class="kapow.robot.plugin.common.support.expression.multipletype.StringProcessorsExpression" serializationversion="0">
            <property name="dataConverters" class="DataConverters">
              <element class="GetVariable" serializationversion="2">
                <property name="variable" class="kapow.robot.plugin.common.support.AttributeName2">
                  <property name="name" idref="1"/>
                </property>
              </element>
              <element class="ReplacePattern">
                <property name="pattern" class="kapow.robot.plugin.common.support.expression.stringexpr.PartialInputMatchingPatternValueStringExpression">
                  <property name="value" class="String">,(.*)</property>
                </property>
              </element>
              <element class="EvaluateExpression" serializationversion="0">
                <property name="expression" class="String">INPUT+"\n"</property>
              </element>
            </property>
          </property>
          <property name="variable" class="kapow.robot.plugin.common.support.AttributeName2">
            <property name="name" idref="1"/>
          </property>
        </property>
        <property name="elementFinders" idref="6"/>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">変数「行データ」を加工
-----------------------------------------------
「行を繰り返しステップ」と「セルを繰り返しステップ」の間の矢印を右クリック
→「ステップを挿入」＞「ブランチを追加」を選択」
→ブランチの先の「エンドステップ」を右クリック＞「ステップを挿入」＞[アクションステップ]を選択
→ステップビュー（画面右）の「アクションを選択」をクリック→「変数の割当」を選択
→値欄の▼をプルダウン＞[コンバーター]を選択
→「変数を取得」をダブルクリック
→設定画面の変数欄で[行データ]を選択
→＋ボタンをクリック＞テキストフォーマット＞[パターンを置き換え]を選択
→設定画面のパターン欄に[,(.*)]と入力
→エクスプレッションを置き換え欄に[$1]と入力＞OKボタンをクリック
→＋ボタンをクリック＞[エクスプレッションを評価]を選択
→エクスプレッション欄に[INPUT+"\n"]と入力

※項目データを加工して、CSV形式に整えていきます。
先頭の[,]は不要なので削除し、改行を追加します。
変数に格納する前の加工中のデータを再加工するときには、INPUTで表します。

</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element idref="12"/>
        </property>
      </object>
      <object class="Transition" serializationversion="3" id="17">
        <property name="name" class="String">CSVファイルを出力</property>
        <property name="stepAction" class="WriteFile" serializationversion="0">
          <property name="fileNameExpression" class="kapow.robot.plugin.common.support.expression.stringexpr.ValueStringExpression">
            <property name="value" class="String">C:\演習問題33\ホテル名一覧出力.csv</property>
          </property>
          <property name="fileContentExpression" class="kapow.robot.plugin.common.support.expression.multipletype.VariableExpression" serializationversion="2">
            <property name="variable" class="kapow.robot.plugin.common.support.AttributeName2">
              <property name="name" class="String">行データ</property>
            </property>
          </property>
          <property name="fileEncoding" class="Encoding">
            <property name="encoding" class="String">windows-31j</property>
          </property>
          <property name="appendToFile" class="Boolean">true</property>
          <property name="createDirectories" class="Boolean">true</property>
        </property>
        <property name="elementFinders" class="ElementFinders"/>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">CSVファイルを出力
-----------------------------------------------
ロボットビューの矢印を右クリック
→「ステップを挿入」＞「アクションステップ」を選択
→ステップビュー（画面右）の「アクションを選択」をクリック
→「ファイル」＞「ファイル出力」を選択
→「ファイル名」欄にファイル名を入力（C:\演習問題33\ホテル名一覧出力.csv）
→「ファイルコンテンツ」欄で［行データl]を選択
→「ファイルエンコード」欄で[Windows日本語]を選択
→「ファイルに追加欄」にチェックをいれる
→「ディレクトリを作成」にチェックをいれる</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element idref="12"/>
        </property>
      </object>
      <object class="Transition" serializationversion="3" id="18">
        <property name="name" class="String">変数「行データ」を空にする</property>
        <property name="stepAction" class="AssignVariable" serializationversion="4">
          <property name="variable" class="kapow.robot.plugin.common.support.AttributeName2">
            <property name="name" idref="1"/>
          </property>
        </property>
        <property name="elementFinders" class="ElementFinders"/>
        <property name="errorHandler" class="ErrorHandler" serializationversion="0"/>
        <property name="comment" class="String">変数「行データ」を空にする
-----------------------------------------------
右クリック＞「ステップを挿入」＞[アクションステップ]を選択
→ステップビュー（画面右）の「アクションを選択」をクリック→「変数の割当」を選択
→値の欄は空欄のまま
→変数欄で[項目データ]を選択

※行データはグローバルにチェックがはいっているため、値を保持しています。
「行を繰り返しステップ」で次の行を繰り返すときには、行データ内を空にしておく必要があります。</property>
        <property name="enabled" idref="3"/>
        <property name="changedProperties" class="java.util.HashSet">
          <element idref="12"/>
        </property>
      </object>
      <object class="End" id="19"/>
    </steps>
    <blockEndStep class="BlockEndStep"/>
    <edges class="ArrayList">
      <object class="TransitionEdge">
        <from idref="4"/>
        <to idref="5"/>
      </object>
      <object class="TransitionEdge">
        <from idref="5"/>
        <to idref="8"/>
      </object>
      <object class="TransitionEdge">
        <from idref="8"/>
        <to idref="9"/>
      </object>
      <object class="TransitionEdge">
        <from idref="9"/>
        <to idref="10"/>
      </object>
      <object class="TransitionEdge">
        <from idref="10"/>
        <to idref="11"/>
      </object>
      <object class="TransitionEdge">
        <from idref="10"/>
        <to idref="16"/>
      </object>
      <object class="TransitionEdge">
        <from idref="11"/>
        <to idref="13"/>
      </object>
      <object class="TransitionEdge">
        <from idref="13"/>
        <to idref="14"/>
      </object>
      <object class="TransitionEdge">
        <from idref="14"/>
        <to idref="15"/>
      </object>
      <object class="TransitionEdge">
        <from idref="16"/>
        <to idref="17"/>
      </object>
      <object class="TransitionEdge">
        <from idref="17"/>
        <to idref="18"/>
      </object>
      <object class="TransitionEdge">
        <from idref="18"/>
        <to idref="19"/>
      </object>
    </edges>
  </property>
  <property name="browserConfigurationSpecification" class="BrowserConfigurationSpecificationWebKit" serializationversion="26"/>
</object>
